#if (!defined(BLIKE0_H))

#define BLIKE0_H	1

#include <stdarg.h>

#if (defined(__cplusplus))
	extern "C" {
#endif

void openWin(int x, int y);
void bl_putc(int c);
void bl_puts(const char *s);
void bl_puts1(const char *s);
void setCol(int c);
void setBCol(int c);
int rbg(int r, int g, int b);
int iCol(int i);
void flshWin(int sx, int sy, int x0, int y0);
int *getGrpB();
void setPix(int x, int y, int c);
void fillRect(int sx, int sy, int x0, int y0);
void drawRect(int sx, int sy, int x0, int y0);
void drawLine(int x0, int y0, int x1, int y1);
int rnd(int max_puls_1);
void wait(int msec);
void color(int c, int b);
void locate(int x, int y);
void bl_printf(const char *s, ...);
int getPix(int x, int y);
void waitNF(int msec);
void inkey();
void cls();
unsigned int bl_clock();
int inptInt(const char *s, ...);
double inptFlot(const char *s, ...);
int bl_scanf(const char *s, ...);
int bl_vscanf(const char *f, va_list ap);
void setMode(int mod);
int bl_rand();
void bl_srand(int seed);

//	int32bit, short16bit, char8bit

#define BL_PSET			0x00000004
#define BL_PAND			0x00000005
#define BL_POR			0x00000006
#define BL_PXOR			0x00000007
#define	BL_FULLHEIGHT	0x00000010
#define	BL_HALFHEIGHT	0x00000018

#define	BL_KEYMODE		0x00000000	// 肩

#if (defined(__cplusplus))
	}
#endif

#endif
