#include "../blike0.h"
#include <stdarg.h>

int blMain();

void bl_init();
void bl_exit();
void bl_putchar8b(int x, int y, int n, int c, int b);
void bl_initFont();
extern unsigned char hankaku[4096];

void bld_openWin(int x, int y);
void bld_flshWin(int sx, int sy, int x0, int y0);
void bld_waitNF();
void bld_exit();
int bld_getSeed();
void *bld_malloc(unsigned int bytes);
void bld_free(void *p, unsigned int bytes);
int bld_vsnprintf(char *b, int n, const char *f, va_list ap);
void bld_initFont();
int bld_maxfonts();

struct BL_WORK {
	int wsiz_x, wsiz_y, csiz_x, csiz_y, cx, cy, col0, col1, tabsiz;
	int tmcount, tmcount0, mod, rand_seed;
	int *gbuf, *cbuf;
	unsigned char *ftyp;
	unsigned char **fptn;
	int *ccol, *cbak;
};

extern struct BL_WORK bl_work;

#if (!defined(NULL))
	#define	NULL	((void *) 0)
#endif

#define	BLD_READYFONTS		0x40000000
#define BLD_READYRANDSEED	0x20000000

#define READY_WINDOW	if (w.wsiz_x == 0) openWin(640, 400);
#define READY_FONTS		if ((bl_work.mod & BLD_READYFONTS) == 0) bld_initFont();
