#include "d_hrb.h"

void bld_openWin(int x, int y)
{
	unsigned char *p;
	static unsigned char t[32];

	api_cmdline(t, 32 - 1);
	p = t;
	while (*p > ' ')
		p++;
	if (p - t > 4 && p[-4] == '.' && p[-3] == 'h' && p[-2] == 'r' && p[-1] == 'b')
		p -= 4;
	*p = '\0';
	dw.wsiz_x = x + 16;
	dw.wbuf = api_malloc(dw.wsiz_x * (y + 37));
	if (dw.wbuf == NULL)
		bld_exit();
	dw.timer = api_alloctimer();
	api_inittimer(dw.timer, TIMER_ID);
	api_settimer(dw.timer, TIMER_INTERVAL / 10);
	dw.win = api_openwin(dw.wbuf, dw.wsiz_x, y + 37, -1, t);
	return;
}

static unsigned char rgb2pal(int r, int g, int b, int x, int y)
{
	static int table[4] = { 3, 1, 0, 2 };
	int i;
	x &= 1; /*  */
	y &= 1;
	i = table[x + y * 2];	/* ԐF邽߂̒萔 */
	r = (r * 21) >> 8;	/*  0`20 ɂȂ */
	g = (g * 21) >> 8;
	b = (b * 21) >> 8;
	r = (r + i) >> 2;	/*  0`5 ɂȂ */
	g = (g + i) >> 2;
	b = (b + i) >> 2;
	return 16 + r + g * 6 + b * 36;
}

void bld_flshWin(int sx, int sy, int x0, int y0)
{
	int ofs_x = 8, ofs_y = 29;	// +16, +37
	int x, y, c;
	for (y = y0; y < y0 + sy; y++) {
		for (x = x0; x < x0 + sx; x++) {
			c = w.gbuf[x + y * w.wsiz_x];
			dw.wbuf[(x + ofs_x) + (y + ofs_y) * dw.wsiz_x]
				= rgb2pal((c >> 16) & 0xff, (c >> 8) & 0xff, c & 0xff, x + ofs_x, y + ofs_y);
		}
	}
	api_refreshwin(dw.win, x0 + ofs_x, y0 + ofs_y, x0 + sx + ofs_x, y0 + sy + ofs_y);
	return;
}
