#include "blikedrv.h"

struct BL_WORK bl_work;
#define	w	bl_work

void bl_init()
{
	int i;
	w.wsiz_x = 0;
	w.cx = w.cy = 0;
	w.col0 = 0xafafaf;
	w.col1 = 0x000000;
	w.tabsiz = 8;
//	w.ftyp = NULL;
	w.fptn = NULL;
	w.ftyp = bld_malloc(bld_maxfonts());
	w.fptn = bld_malloc(bld_maxfonts() * sizeof (unsigned char *));
	if (w.ftyp == NULL || w.fptn == NULL) {
		bld_exit();
	}
	for (i = 0; i < 65536 * 4; i++) {
		w.ftyp[i] = 0;
		w.fptn[i] = NULL;
	}
	w.tmcount0 = w.tmcount = 0;
	w.mod = BL_PSET | BL_FULLHEIGHT;
	return;
}

void bl_exit()
{
	if (w.gbuf != NULL) {
		bld_free(w.gbuf, w.wsiz_x * w.wsiz_y * sizeof (int));
		w.gbuf = NULL;
	}
	if (w.cbuf != NULL) {
		bld_free(w.cbuf, w.csiz_x * w.csiz_y * sizeof (int));
		w.cbuf = NULL;
	}
	if (w.ccol != NULL) {
		bld_free(w.ccol, w.csiz_x * w.csiz_y * sizeof (int));
		w.ccol = NULL;
	}
	if (w.cbak != NULL) {
		bld_free(w.cbak, w.csiz_x * w.csiz_y * sizeof (int));
		w.cbak = NULL;
	}
	if (w.ftyp != NULL) {
		bld_free(w.ftyp, bld_maxfonts());
		w.ftyp = NULL;
	}
	if (w.fptn != NULL) {
		bld_free(w.fptn, bld_maxfonts() * sizeof (unsigned char *));
		w.fptn = NULL;
	}
	return;
}
