#include "../common/blikedrv.h"
#include "apilib.h"
#include "setjmp.h"

struct BLD_WORK {
	jmp_buf jb;
	int win, wsiz_x, timer;
	unsigned char *wbuf;
};

extern struct BLD_WORK bld_work;

#define w	bl_work
#define dw	bld_work

void HariMain();
void *bld_malloc(unsigned int bytes);
void bld_free(void *p, unsigned int bytes);
int bld_maxfonts();
void bld_flshWin(int sx, int sy, int x0, int y0);
int bld_vsnprintf(char *b, int n, const char *f, va_list ap);
int bld_getSeed();
void bld_exit();
void bld_openWin(int x, int y);
void bld_waitNF();

#define TIMER_ID			 1
#define TIMER_INTERVAL		10
