#include "d_hrb.h"

struct BLD_WORK bld_work;

void HariMain()
{
	api_initmalloc();
	bl_init();
	dw.win = -1;
	dw.timer = -1;
	dw.wbuf = NULL;
	if (setjmp(dw.jb) == 0)
		blMain();
	bl_exit();
	api_end();
	return;
}

void *bld_malloc(unsigned int bytes)
{
	return api_malloc(bytes);
}

void bld_free(void *p, unsigned int bytes)
{
	api_free(p, bytes);
	return;
}

int bld_maxfonts()
{
	return 1024;	/* b */
}

void bld_exit()
{
	if (dw.win != -1) {
		api_closewin(dw.win);
		dw.win = -1;
	}
	if (dw.timer != -1) {
		api_freetimer(dw.timer);
		dw.timer = -1;
	}
	if (dw.wbuf != NULL) {
		api_free(dw.wbuf, dw.wsiz_x * (w.wsiz_y + 37));
		dw.wbuf = NULL;
	}
	bl_exit();
	longjmp(dw.jb, 1);
}
