#include "../common/blikedrv.h"
#include <windows.h>
#include <setjmp.h>

struct BLD_WORK {
	jmp_buf jb;
	HINSTANCE hi;
	HWND hw;
	BITMAPINFO bmi;
};

extern struct BLD_WORK bld_work;

#define w	bl_work
#define dw	bld_work

void bld_openWin(int x, int y);
void bld_flshWin(int sx, int sy, int x0, int y0);
int WINAPI WinMain(HINSTANCE hInst, HINSTANCE hPrevInst, LPSTR pCmdLine, int showCmd);
LRESULT CALLBACK WndProc(HWND hw, unsigned int msg, WPARAM wp, LPARAM lp);
void bld_waitNF();
void bld_exit();
int bld_getSeed();
void *bld_malloc(unsigned int bytes);
void bld_free(void *p, unsigned int bytes);
int bld_maxfonts();
int bld_vsnprintf(char *b, int n, const char *f, va_list ap);

#define TIMER_ID			 1
#define TIMER_INTERVAL		10
